/*
 Name:		TestGame.ino
 Created:	12/04/2024 22:46:42
 Finished:	30/04/2024 22:37:30
 Author:	J&B Software 84 by Testa Massimiliano - www.jbs84.com
*/

/********
 * Arduino Game v1.0
 * By Testa Massimiliano
 *
 * A simple Game Plarform and Space on the Arduino using a TV for output.
 *
 */

#include <TimerThree.h>
#include <TVout.h>
#include <fontALL.h>

#define ASSE_X 0 //analog
#define ASSE_Y 1 //analog
#define BUTTON_ONE_PIN 2 //digital to start game

TVout TV;

#pragma region ############################################ ALL VARIABLES

uint8_t PlatformSpace = 0;
int level = 1;
int score = 0;
float energy = 0;
//###### 
uint8_t poshero = 0;
float yhero = 0, oyhero = 0;
uint8_t xhero = 0, oxhero = 0;
uint8_t wdherocol = 0, hgherocol = 0;
int mxstart = 0, mxend = 0;
int mystart = 0, myend = 0;

//###### 
bool slt = false;
float psslt = .5;
int yslt = 0;

float vi = 10;
float ovi = 10;
float pvi = 0.25;
int	vl = random(20) + 1;
char* dt = "100";

//###### 
uint8_t xdel = random(20) * 5, xqta = random(4) + 1, xcq = 0;
uint8_t mbuco[6][4];
//######
const uint8_t tms = 7;
uint8_t totmos = tms;
uint8_t posmoster[tms] = { 0 };
uint8_t lsmos[tms] = { 0,0,0 }, dsmos[tms] = { 0,0,0 };
uint8_t wdmoscol[tms] = { 0,0,0 }, hgmoscol[tms] = { 0,0,0 };
float xmos[tms] = { 0.0,0,0 }, ymos[tms] = { 0.0,0,0 }, oxmos[tms] = { 0.0,0,0 }, oymos[tms] = { 0.0,0,0 }, psxmos[tms] = { 0.0,0,0 };
uint8_t nxmos = 0;
//######
uint8_t xobj[10] = { 0,0,0,0,0,0,0 }, yobj[10] = { 0,0,0,0,0,0,0 };
uint8_t wdobjcol[10] = { 0,0,0,0,0,0,0 }, hgobjcol[10] = { 0,0,0,0,0,0,0 };
bool objlive[10] = { true,true,true,true,true,true,true };
//######
uint8_t xlife = 0, ylife = 0;
uint8_t wdlifecol = 0, hglifecol = 0;
bool lifelive = true;
//###### 
bool endlevel = false;
uint8_t maxobj = 0, endobj = 0;;

uint8_t xbomb = random(20) * 5, ybomb = 0, tbomb = 0;
bool btnPress = false;
//######
const uint8_t totmiss = 3;
float xmiss[totmiss] = { 0 }, ymiss[totmiss] = { 0 };
float oxmiss[totmiss] = { 0 }, oymiss[totmiss] = { 0 }, psmiss[totmiss] = { 0 };
uint8_t startmiss[totmiss] = { 0 };
bool livemiss[totmiss] = { 0 }, endmiss = false;

const uint8_t totAlien = 5;
float pxalien[totAlien] = { 0 }, pyalien[totAlien] = { 0 };
float xalien[totAlien] = { 0 }, yalien[totAlien] = { 0 };
float oxalien[totAlien] = { 0 }, oyalien[totAlien] = { 0 };
uint8_t a[totAlien] = { 0 };
uint8_t iniastro[totAlien] = { 0 };
bool liveastro[totAlien] = { 0 }, endAlien = false;
uint8_t nxmove = 0;

uint8_t xfire[5] = { 0 }, oxfire[5] = { 0 };
uint8_t yfire[5] = { 0 }, oyfire[5] = { 0 };
bool fireon[5] = { false };
uint8_t fire = 0;

float fcos[157] = { 0 }, fsin[157] = { 0 };

uint8_t xexp = 0, yexp = 0, oxexp = 0, oyexp = 0;
bool liveexp = false;
float rg = 1;
uint8_t rt = 0;
//###### 
uint8_t spaceearth = 0, astromiss = 0;;
int currPosLevel = 0, endLevelSpace = 0, endLevelEarth = 0;
int currPosEarthSpace = 0, endLevelEarthSpace = 0;

#pragma endregion

//#################################################################################################################################################
//########################################################################################### VOID 
void setup() {
	//###### INITIALIZE INTERRUPT EFFECT SOUND 
	Timer3.initialize(2000);
	Timer3.attachInterrupt(soundCallback); //###### 
	Timer3.stop();

	Serial.begin(9600);


	//###### 
	//TV.begin(_PAL);// (default 128x96)
	TV.begin(_PAL, 111, 111);//107x104

	//  pinMode(BUTTON_ONE_PIN, INPUT);      // sets the digital pin as output
	Serial.println("");
	//###### 
	TV.clear_screen();

	//###### 
	TV.select_font(font4x6);

	//https://forum.arduino.cc/t/help-code-issue-tvout/1219326/3

	//###### COS E SIN
	float fa = 0;
	for (uint8_t t = 0; t < 157; t++) { fa += .04; fcos[t] = cos(fa); fsin[t] = sin(fa); }

	//###### MAIN MENU
	mainMenu();

	////###### USE WHEN COMMENT MAIN MENU
	//randomSeed(level);
	//###### 
	//energy = 1;
	//score = 0;
	////###### EXPLOSION
	//liveexp = false;
	//xexp = 0; yexp = 0;
	//oxexp = xexp; oyexp = yexp;
	////###### 
	//PlatformSpace = 0;
	////###### 
	//SeletTypeStartGame();


	//###### SIZE COLLISION HEART ENERGY
	wdlifecol = 4;
	hglifecol = 5;
	//###### SIZE COLLISION OBJECT PLATFORM
	for (uint8_t t = 0; t < 10; t++) { wdobjcol[t] = 4, hgobjcol[t] = 5; }
	//for (uint8_t t = 0; t < 10; t++) { wdobjcol[t] = 3, hgobjcol[t] = 4; }
	//###### SIZE COLLISION MOSTER PLATFORM
	for (uint8_t t = 0; t < tms; t++) { wdmoscol[t] = 5;	hgmoscol[t] = 4; }
	//###### SIZE COLLISION HERO PLATFORM
	wdherocol = 2;
	hgherocol = 6;

}

#pragma region ############################################ SOUND EFFECT

//notes={'C' 'E' 'B' 'A' 'G'}
//float freq[5] = { 523.251, 659.255, 493.88, 440.00, 392.00 };
//song={'C' 'C' 'E' 'C' 'B' 'A' 'G'}              % your song
//float dur[7] = { 0.125, 0.125, 0.125, 0.06, 0.5, 0.5, 2, 1 };

//###### INTERRUPT EFECT SOUND
volatile uint8_t snd = 0, sndmx = 157 / 2, typeEffect = 0;;
volatile unsigned long tmr = millis();
volatile int delaySound = 10, ps = 0;

//#################################################################################################################################################
//########################################################################################### VOID EFFECT GAME
void effect(uint8_t neff) {
	Timer3.stop();
	tmr = millis();
	switch (neff)
	{
	case 0://###### COLPITO 
		sndmx = 157 / 2;
		snd = 0;
		delaySound = 5;
		break;
	case 1://###### DEAD 
		sndmx = 7;
		snd = 0;
		ps = (185 - 130) / sndmx;
		delaySound = 100;
		break;
	case 2://###### FIRE
		sndmx = 10;
		snd = 0;
		ps = (2093 - 1000) / sndmx;
		delaySound = 1;
		break;
	case 3://###### OBJECT
		sndmx = 157 / 4;
		snd = 0;
		delaySound = 1;
		break;
	case 4://###### HEART
		sndmx = 157 / 4;
		snd = 0;
		delaySound = 1;
		break;
	case 5://###### JUMP
		sndmx = 15;
		ps = 10;
		snd = 0;
		delaySound = 1;
		break;
	case 6://###### LEVEL
		sndmx = 78;
		snd = 0;
		delaySound = 1;
		break;

	default:
		break;
	}
	typeEffect = neff;
	Timer3.start();
}

//#################################################################################################################################################
//########################################################################################### VOID SOUND CALLBACK
void soundCallback(void) {
	if (millis() - tmr > delaySound) {
		snd++; if (snd >= sndmx) { Timer3.stop(); }
		switch (typeEffect)
		{
		case 0:
			//###### COLPITO 
			TV.tone(16 * fsin[snd], 50);
			break;
		case 1:
			//###### DEAD 
			TV.tone(185 - (ps * snd), 100);
			break;
		case 2:
			//###### FIRE
			TV.tone(2093 - (ps * snd), 50);
			break;
		case 3:
			//###### OBJECT
			TV.tone(2500 * (fcos[snd] * fsin[snd]), 50);
			break;
		case 4:
			//###### HEART
			TV.tone((snd * 10) + (2000 * fsin[snd]), 50);
			break;
		case 5:
			//###### JUMP
			TV.tone(20 * (ps * snd), 50);
			break;
		case 6:
			//###### LEVEL
			//TV.tone(100 - -(10 * (10 * snd)), 50);
			TV.tone((snd * 10) + (100 * fsin[78 + snd]), 50);
			break;
		default:
			break;
		}

		tmr = millis();
	}
}

#pragma endregion

#pragma region ############################################ GENERIC

//#################################################################################################################################################
//########################################################################################### VOID MAIN MENU
void mainMenu() {
	uint8_t mnu = 0;
	unsigned long tmr = millis();

repeat:

	TV.clear_screen();

	TV.select_font(font8x8);
	TV.print(23, 10, "JOURNEY");

	//###### 
	TV.select_font(font4x6);
	TV.print(28, 20, "INTO ARDUINO");
	TV.print(15, 90, "BY J&B SOFTWARE 84");
	TV.print(45, 98, "2024");

	TV.print(30, 46, "INSTRUCTION");
	TV.print(13, 55, "PRESS FIRE TO START");

	while (!digitalRead(BUTTON_ONE_PIN)) {
		TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
		//###### 
		mystart = analogRead(ASSE_Y);
		if (mystart > 510) { mnu = 1; effect(5); }
		else if (mystart < 490) { mnu = 0; effect(5); }
		switch (mnu)
		{
		case 0:
			if (millis() - tmr <= 300) {
				TV.print(30, 46, "INSTRUCTION");
				TV.print(13, 55, "PRESS FIRE TO START");
			}
			if (millis() - tmr >= 300) { TV.draw_rect(27, 45, 50, 6, BLACK, BLACK); }
			if (millis() - tmr >= 600) { tmr = millis(); }
			break;
		case 1:
			if (millis() - tmr <= 300) {
				TV.print(30, 46, "INSTRUCTION");
				TV.print(13, 55, "PRESS FIRE TO START");
			}
			if (millis() - tmr >= 300) { TV.draw_rect(10, 54, 80, 6, BLACK, BLACK); }
			if (millis() - tmr >= 600) { tmr = millis(); }
			break;
		default:
			break;
		}
		TIMSK3 = 0b00000000;//###### DISABLE INTERRUPT TIMER 3 (disattiva interrupt timer 3)
		TV.delay_frame(1);

	}
	if (mnu == 0) {
		TV.clear_screen();
		TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
		effect(6);
		TV.delay(500);
		TV.select_font(font4x6);
		TV.print(30, 0, "INSTRUCTION");
		TV.print(0, 1 * 7, "USE JOY TO MOVE YOUR HERO.");
		TV.print(0, (2 * 7) + 1, "PLATFORM:");
		TV.print(0, 3 * 7, "GRAB ALL THE CROSSES TO FINISH LEVEL.");
		TV.print(0, (5 * 7) - 1, "TAKE THE HEART FOR EXTRA ENERGY.");
		TV.print(0, 7 * 7 - 2, "USE BUTTON TO JUMP.");
		TV.print(0, 8 * 7, "SPACE:");
		TV.print(0, 9 * 7, "DESTRUCT ALL ALIEN AND ALL MISSILE.");
		TV.print(0, 11 * 7, "WHEN DESTRUCT ALIEN TAKE ENERGY.");
		TV.print(0, 13 * 7, "USE BUTTON TO FIRE.");
		TV.print(6, 15 * 7, "PRESS FIRE TO BACK MENU");
		while (!digitalRead(BUTTON_ONE_PIN)) {}
		TV.clear_screen();
		effect(6);
		TV.delay(500);
		goto repeat;
	}
	TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
	effect(6);
	TV.clear_screen();
	TV.delay(500);
	//###### 
	level = 1;
	//###### 
	randomSeed(level);
	//###### 
	energy = 25;
	score = 0;

	//###### EXPLOSION
	liveexp = false;
	xexp = 0; yexp = 0;
	oxexp = xexp; oyexp = yexp;
	//###### 
	PlatformSpace = 0;
	//###### 
	SeletTypeStartGame();

}

//#################################################################################################################################################
//########################################################################################### VOID SELET TYPE START GAME (PLATFORM/SPACE)
void SeletTypeStartGame() {
	//###### PLATFORM=0 - SPACE=1
	if (PlatformSpace == 0) {
#pragma region ############################################ PLATFORM
		//###### GENERATORE DI SPAZI NELLA MAPPA
		generaMappa();

		//###### GENERATORE MOSTRI
		generaMostri();

		//###### GENERATORE OGGETTI
		generaoggetti();

		//###### START HERO
		xhero = 5;
		yhero = 85;

		endlevel = false;

		//###### 
		currPosLevel = 0;
		endLevelEarth = random(5, 12);

#pragma endregion
	}
	else {
#pragma region ############################################ SPACE
		//###### START HERO
		xhero = 5;
		yhero = 50;

		//###### 
		endAlien = false; endmiss = false;

		//###### AZZERA ASTRO/MISSILE
		for (uint8_t t = 0; t < totAlien; t++) { iniastro[t] = 0; liveastro[t] = false; }
		for (uint8_t t = 0; t < totmiss; t++) { livemiss[t] = false; }

		//###### TYPE EARTH
		spaceearth = random(0, 3);//###### DECIDE QUALE MODELLO SI SPAZIO TERRA
		callnext();

		//###### 
		currPosLevel = 0;
		endLevelSpace = random(5, 12);

#pragma endregion
	}
	//###### 
	slt = false;
	//###### 
	liveexp = false;
	rg = 1;
	rt = 0;
	//###### 
	for (uint8_t t = 0; t < 5; t++) { fireon[t] = false; }

}

//#################################################################################################################################################
//########################################################################################### VOID 
void printLevel(int lev) {
	TV.select_font(font8x8);
	TV.print(20, 40, "LEVEL ");
	TV.print(65, 40, lev);
	//###### 
	TV.select_font(font4x6);
}

//#################################################################################################################################################
//########################################################################################### VOID 
void printScore(uint8_t x, uint8_t y, int sc, uint8_t spl) {
	TV.print(x + 24, y, sc);
	TV.print(x, y, (char*)"SCORE:");
	if (spl == 1) { TV.draw_line(x - 1, y, x - 1, y + 5, BLACK); }
}

#pragma endregion

#pragma region ############################################ NOT USED
//#################################################################################################################################################
//########################################################################################### VOID 
void point(uint8_t x, uint8_t y, int value, char c) {

	TV.draw_line(x, y + 0, x, y + 2, c);
	uint8_t v = 0;
	switch (value)
	{
	case 10:v = 1; break;
	case 100:v = 2; break;
	case 1000:v = 3; break;
	case 10000:v = 4; break;
	default:break;
	}
	for (byte t = 0; t < v; t++) {
		uint8_t x1 = x + (t * 4);
		TV.draw_line(x1 + 3, y + 0, x1 + 3, y + 0, c);
		TV.draw_line(x1 + 2, y + 1, x1 + 2, y + 1, c);
		TV.draw_line(x1 + 4, y + 1, x1 + 4, y + 1, c);
		TV.draw_line(x1 + 3, y + 2, x1 + 3, y + 2, c);
	}
}

//#################################################################################################################################################
//########################################################################################### VOID 
void pointb(uint8_t x, uint8_t y, int value, char c) {
	TV.draw_line(x, y, x, y + 3, c);
	uint8_t v = 0;
	switch (value)
	{
	case 10:v = 1; break;
	case 100:v = 2; break;
	case 1000:v = 3; break;
	case 10000:v = 4; break;
	default:break;
	}
	for (byte t = 0; t < v; t++) {
		uint8_t x1 = x + (t * 4);
		TV.draw_line(x1 + 3, y + 0, x1 + 3, y + 0, c);
		TV.draw_line(x1 + 2, y + 1, x1 + 2, y + 2, c);
		TV.draw_line(x1 + 4, y + 1, x1 + 4, y + 2, c);
		TV.draw_line(x1 + 3, y + 3, x1 + 3, y + 3, c);
	}
}

//#################################################################################################################################################
//########################################################################################### VOID 
void man(uint8_t x, uint8_t y, char c) {
	//###### TESTA
	TV.draw_rect(0 + x, 0 + y, 2, 2, c);
	//###### CORPO
	TV.draw_line(1 + x, 3 + y, 1 + x, 3 + 3 + y, c);
	//###### BRACCIA
	TV.draw_line(0 + x, 4 + y, 3 + x, 4 + y, c);
	TV.set_pixel(x - 1, 3 + y, c);
	TV.set_pixel(3 + x, 3 + y, c);
	//###### GAMBE
	TV.draw_line(0 + x, 7 + y, 0 + x, 7 + 3 + y, c);
	TV.draw_line(2 + x, 7 + y, 2 + x, 7 + 3 + y, c);
}
#pragma endregion

#pragma region ############################################ PLATFORM

//#################################################################################################################################################
//########################################################################################### VOID GENERA OGGETTI
void generaoggetti() {
	maxobj = random(3, 10);
	endobj = maxobj;

	for (uint8_t t = 0; t < 10; t++) { objlive[t] = false; }

	for (uint8_t t = 0; t < maxobj; t++) {
		xobj[t] = random(1, 100), yobj[t] = (random(1, 7) * 15) - 6;
		objlive[t] = true;
	}
	//###### CUORE LIVE
	xlife = random(1, 100);
	ylife = (random(1, 7) * 15) - 6;
	lifelive = true;
}

//#################################################################################################################################################
//########################################################################################### VOID GENERA MOSTRI
void generaMostri() {
	nxmos = random(0, 3);//###### CHANGE TYPE MOSTER
	totmos = random(3, 7);
	for (uint8_t t = 0; t < totmos; t++) {
		lsmos[t] = 5 + (random(10) * 4);
		dsmos[t] = lsmos[t] + (random(20) * 4);
		if (dsmos[t] < lsmos[t] + 10) { dsmos[t] = lsmos[t] + 10; }
		if (dsmos[t] > 100) { dsmos[t] = 100; }
		xmos[t] = lsmos[t] + (dsmos[t] - lsmos[t]) / 2;
		ymos[t] = 9 + (random(6)) * 15;
		oxmos[t] = xmos[t];
		oymos[t] = ymos[t];

		psxmos[t] = ((float)random(3, 11) / 20) + (float)nxmos / 5;
		//Serial.println(psxmos[t]);
	}
}

//#################################################################################################################################################
//########################################################################################### VOID 
void generaMappa() {

	xdel = random(20) * 5;

	//###### RESET MAPPA
	for (byte t = 0; t < 6; t++) { for (uint8_t t1 = 0; t1 < 4; t1++) { mbuco[t][t1] = 255; } }
	//###### GENERATORE DI SPAZI NELLA MAPPA
	for (byte t = 0; t < 6; t++) {
		//Serial.print(t); Serial.print(" - "); Serial.print(xqta);
		for (uint8_t t1 = 0; t1 < xqta; t1++) {
			mbuco[t][xcq] = xdel;
			xdel = random(20) * 5;
			//Serial.print(" - "); Serial.print(xcq);
			//Serial.print(" - "); Serial.print(mbuco[t][xcq]);
			xcq++;
		}
		//Serial.println("");
		xcq = 0;
		xqta = random(4) + 1;
		xdel = random(20) * 5;
	}
	////###### 
	//Serial.println("***********");

	//for (uint8_t t = 0; t < 6; t++) {
	//	for (uint8_t t1 = 0; t1 < 4; t1++) {
	//		xdel = mbuco[t][t1];
	//		if (xdel != 255) {
	//			Serial.print(t); Serial.print(" - "); Serial.println(xdel);
	//		}
	//	}
	//}

}

//#################################################################################################################################################
//########################################################################################### VOID 
void hero(uint8_t x, uint8_t y, uint8_t leftright, char c) {

	if (leftright == 1) { TV.draw_rect(x, y - 1, 1, 1, c); }
	else { TV.draw_rect(x - 1, y - 1, 1, 1, c); }
	//TV.draw_rect(x - wdherocol / 2, (y + 2) - hgherocol / 2, wdherocol, hgherocol, c);
	//TV.draw_rect(x, y - 1, 1, 1, c);

	TV.draw_line(x - 2, y + 1, x - 1, y + 2, c);
	TV.draw_line(x + 1, y + 2, x + 2, y + 1, c);

	TV.draw_line(x, y, x, y + 3, c);

	TV.draw_line(x - 1, y + 4, x - 1, y + 5, c);
	TV.draw_line(x + 1, y + 4, x + 1, y + 5, c);

}

//#################################################################################################################################################
//########################################################################################### VOID 
void moster(uint8_t x, uint8_t y, uint8_t leftright, uint8_t type, char c) {
	//TV.draw_rect((x - 1) - wdmoscol / 2, y - hgmoscol / 2, wdmoscol, hgmoscol, c);
	switch (type)
	{
	case 0:
		if (leftright == 1) {
			TV.set_pixel(x - 3, y - 2, c);
			TV.set_pixel(x - 3, y, c);
			TV.set_pixel(x - 3, y + 2, c);
		}
		else {
			TV.set_pixel(x + 3, y - 2, c);
			TV.set_pixel(x + 3, y, c);
			TV.set_pixel(x + 3, y + 2, c);
		}
		TV.draw_circle(x, y, 2, c);
		break;
	case 1:
		if (leftright == 1) {
			TV.draw_rect(x - 1, y - 2, 2, 4, c);
			TV.set_pixel(x + 2, y - 2, c);
			TV.set_pixel(x + 2, y, c);
			TV.set_pixel(x + 2, y + 2, c);
			TV.set_pixel(x, y - 1, WHITE);
		}
		else {
			TV.draw_rect(x - 1, y - 2, 2, 4, c);
			TV.set_pixel(x - 2, y - 2, c);
			TV.set_pixel(x - 2, y, c);
			TV.set_pixel(x - 2, y + 2, c);
			TV.set_pixel(x, y - 1, WHITE);
		}
		break;
	case 2:
		TV.draw_circle(x, y, 2, c);
		TV.set_pixel(x - 1, y - 1, c);
		TV.set_pixel(x + 1, y - 1, c);
		TV.set_pixel(x, y + 1, c);
		break;
	default:
		break;
	}

}

//#################################################################################################################################################
//########################################################################################### VOID 
void cuore(uint8_t x, uint8_t y, char c) {
	//cuore
	TV.draw_line(x - 2, y, x - 2, y + 1, c);
	TV.set_pixel(x - 1, y - 1, c);

	TV.set_pixel(x, y, c);

	TV.set_pixel(x + 1, y - 1, c);
	TV.draw_line(x + 2, y, x + 2, y + 1, c);

	TV.set_pixel(x - 1, y + 2, c);
	TV.set_pixel(x, y + 3, c);
	TV.set_pixel(x + 1, y + 2, c);
}
void croce(uint8_t x, uint8_t y, char c) {
	TV.draw_line(x, y, x + 3, y, c);
	TV.draw_line(x + 1, y - 1, x + 1, y + 3, c);
}

//#################################################################################################################################################
//########################################################################################### VOID 
void porta(uint8_t x, bool c) {
	if (!c) {
		TV.draw_rect(x, 2, 5, 10, WHITE, WHITE);
		TV.draw_line(x + 1, 7, x + 3, 7, BLACK);
	}
	else {
		TV.draw_rect(x, 2, 5, 10, WHITE, BLACK);
	}
}

#pragma endregion

#pragma region ############################################ ALIEN

//#################################################################################################################################################
//########################################################################################### VOID GENERA ALIEN
void generalien(uint8_t y, bool vl) {
	//###### ALIEN
	for (uint8_t t = 0; t < totAlien; t++) {
		xalien[t] = 0, yalien[t] = 0;
		pxalien[t] = 82, pyalien[t] = y + (random(5) * 4);
		oxalien[t] = pxalien[t], oyalien[t] = pyalien[t];
		a[t] = 0;
		iniastro[t] = 0;
		liveastro[t] = vl;
	}
	iniastro[0] = 1;
	endAlien = false;
}

//#################################################################################################################################################
//########################################################################################### VOID GENERA MISSILE
void generamissile(bool vl) {
	for (uint8_t t = 0; t < totmiss; t++) {
		xmiss[t] = 102;
		ymiss[t] = 0;
		oxmiss[t] = xmiss[t];
		oymiss[t] = ymiss[t];
		psmiss[t] = 1;
		livemiss[t] = vl;
		startmiss[t] = 30 + random(10) * 5;
	}
	endmiss = false;
}

//#################################################################################################################################################
//########################################################################################### VOID 
void alien(uint8_t x, uint8_t y, uint8_t ps, char c) {
	//TV.draw_rect(x - 2, y, 4, 4, c);
	switch (ps)
	{
	case 0:
		TV.draw_line(x - 2, y, x, y + 2, c);
		TV.draw_line(x, y + 2, x + 2, y, c);
		break;
	case 1:
		TV.draw_rect(x, y, 2, 2, c);
		break;
	case 2:
		TV.draw_line(x - 2, y + 2, x, y, c);
		TV.draw_line(x, y, x + 2, y + 2, c);
		TV.draw_line(x - 1, y + 2, x + 2, y + 2, c);
		break;
	default:
		break;
	}
}

//#################################################################################################################################################
//########################################################################################### VOID 
void missile(uint8_t x, uint8_t y, uint8_t ps, char c) {
	//TV.draw_rect(x - 1, y - 3, 2, 5, c);
	TV.draw_line(x, y, x, y - 3, c);
	TV.draw_line(x - 1, y + 2, x - 1, y - 1, c);
	TV.draw_line(x + 1, y + 2, x + 1, y - 1, c);
}

//#################################################################################################################################################
//########################################################################################### VOID 
void astro(uint8_t x, uint8_t y, char c) {
	uint8_t x1 = x - 1;
	TV.draw_line(x1, y - 1, x1 + 2, y - 1, c);
	TV.draw_line(x, y, x + 2, y, c);
	TV.draw_line(x1, y + 1, x1 + 2, y + 1, c);
}

//#################################################################################################################################################
//########################################################################################### VOID EXPLOSION
void explosion(uint8_t x, uint8_t y, char c) {
	if (c == WHITE) {
		rg += .2; if (rg > 10) { rg = 1; liveexp = false; return; }
		//rg += .2; if (rg > 10) { rg = 1;  }
		rt += 1; if (rt >= 27) { rt = 0; }
	}

	TV.set_pixel(x + rg * fcos[0 + rt], y + rg * fsin[0 + rt], c);
	TV.set_pixel(x + rg * fcos[26 + rt], y + rg * fsin[26 + rt], c);
	TV.set_pixel(x + rg * fcos[52 + rt], y + rg * fsin[52 + rt], c);
	TV.set_pixel(x + rg * fcos[78 + rt], y + rg * fsin[78 + rt], c);
	TV.set_pixel(x + rg * fcos[104 + rt], y + rg * fsin[104 + rt], c);
	TV.set_pixel(x + rg * fcos[130 + rt], y + rg * fsin[130 + rt], c);
}

//#################################################################################################################################################
//########################################################################################### VOID 
void callnext() {
	//###### EART UP
	if (spaceearth == 0) {
		generalien(65, true);
		astromiss = 0;//###### 0=ASTRO - 1=MISSILE
		nxmove = random(0, 3);
	}
	else if (spaceearth == 1) {//###### EART DOWN
		if (random(0, 2) == 1) {
			generalien(25, true);
			astromiss = 0;//###### 0=ASTRO - 1=MISSILE
			nxmove = random(0, 3);
		}
		else
		{
			generamissile(true);
			astromiss = 1;//###### 0=ASTRO - 1=MISSILE
		}
	}
	else if (spaceearth == 2) {//###### EART UP/DOWN
		//###### RESET ASTRO
		for (uint8_t t = 0; t < totAlien; t++) { liveastro[t] = false; }
		astromiss = 0;//###### 0=ASTRO - 1=MISSILE
		currPosEarthSpace = 0;
		endLevelEarthSpace = 1000 + random(10) * 200;//###### DA 1000>3000
	}

}

//#################################################################################################################################################
//########################################################################################### VOID ENERGY HERO
void energyHero(float vl) {
	energy += vl;
	if (energy > 49) { energy = 49; }
	//if (energy <= 0) { energy = 49; }
	if (energy <= 0) {
		xexp = xhero;
		yexp = yhero;
		liveexp = true;
		effect(1);
		//###### FINAL EXPLOSION HERO
		while (liveexp)
		{
			explosion(xexp, yexp, WHITE);
			TIMSK3 = 0b00000000;//###### DISABLE INTERRUPT TIMER 3 (disattiva interrupt timer 3)
			TV.delay_frame(3);
			TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
			explosion(xexp, yexp, BLACK);
		}
		TV.select_font(font8x8);
		TV.print(18, 40, "GAME OVER");
		//###### 
		TV.select_font(font4x6);
		TV.delay(3000);
		//###### 
		mainMenu();
		level = 1;
		//###### 
		randomSeed(level);
		//###### 
		PlatformSpace = 0;
		//###### 
		SeletTypeStartGame();

		// RIPARTI GIOCO VAI A MAIN MENU
	}
}

#pragma endregion

//#################################################################################################################################################
//########################################################################################### VOID MAIN LOOP
void loop() {

	//###### PLATFORM=0 - SPACE=1
	if (PlatformSpace == 0) {
#pragma region ############################################ PLATFORM
		TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
		//###### 
		mxstart = analogRead(ASSE_X);
		//Serial.println(mstart);	return;
		if (mxstart > 510) { xhero += 1; if (xhero > 100) { xhero = 100; } }
		if (mxstart < 490) { xhero -= 1; if (xhero < 2) { xhero = 2; } }
		mxend = mxstart;

		//###### LINEE LIVELLO
		for (byte t = 13; t <= 103; t += 15) { TV.draw_line(0, t, 103, t, WHITE); }
		//###### BUCHI LIVELLO
		for (uint8_t t = 0; t < 6; t++) {
			for (uint8_t t1 = 0; t1 < 4; t1++) {
				xdel = mbuco[t][t1];
				if (xdel > 0) { TV.draw_line(xdel, (t * 15) + 13, xdel + 5, (t * 15) + 13, BLACK); }
			}
		}
		//###### PORTA
		porta(97, endlevel);

		//###### CROCE (CROSS)
		for (uint8_t t = 0; t < maxobj; t++) {
			if (objlive[t]) {
				//TV.draw_rect((xobj[t] + 1) - wdobjcol[t] / 2, (yobj[t] - 1) - hgobjcol[t] / 2, wdobjcol[t], hgobjcol[t], WHITE);
				croce(xobj[t], yobj[t], WHITE);
			}
		}

		//###### CUORE (HEART)
		if (lifelive) {
			//TV.draw_rect(xlife - wdlifecol / 2, (ylife + 1) - hglifecol / 2, wdlifecol, hglifecol, WHITE);
			cuore(xlife, ylife, WHITE);
		}
		TIMSK3 = 0b00000000;//###### DISABLE INTERRUPT TIMER 3 (disattiva interrupt timer 3)

		//###### 
		//if (tbomb < 5) {
		//	TV.draw_line(xbomb, ybomb - 1, xbomb + 5, ybomb - 1, BLACK);
		//	TV.draw_line(xbomb, ybomb, xbomb + 5, ybomb, WHITE);
		//	ybomb++;
		//	if (ybomb >= 90) {
		//		TV.draw_line(xbomb, ybomb - 1, xbomb + 5, ybomb - 1, BLACK);
		//		ybomb = 0; xbomb = random(20) * 5; tbomb++;
		//	}
		//}
		//###### 
		//point(25, 5, 1000, WHITE);
		//pointb(65, 5, 100, WHITE);

		//###### MOSTER
		for (uint8_t t = 0; t < totmos; t++) {
			moster(oxmos[t], oymos[t], posmoster[t], nxmos, BLACK);
			xmos[t] += psxmos[t];
			if (xmos[t] > oxmos[t]) { posmoster[t] = 1; }
			else if (xmos[t] < oxmos[t]) { posmoster[t] = 0; }
			if (xmos[t] > dsmos[t] || xmos[t] < lsmos[t]) { psxmos[t] = -psxmos[t]; }
			moster(xmos[t], ymos[t], posmoster[t], nxmos, WHITE);
			oxmos[t] = xmos[t]; oymos[t] = ymos[t];
		}

		//###### EXPLOSION
		if (liveexp) {
			explosion(oxexp, oyexp, BLACK);
			explosion(xexp, yexp, WHITE);
		}
		oxexp = xexp;
		oyexp = yexp;

		//###### SCORE GAME
		printScore(0, 105, score, 0);

		//###### ENERGY HERO
		TV.draw_rect(52, 105, 50, 4, WHITE, BLACK);
		TV.draw_rect(52, 106, energy, 2, WHITE, WHITE);

		//###### 
		hero(oxhero, yhero, poshero, BLACK);

		//###### 
		uint8_t btnslt = digitalRead(BUTTON_ONE_PIN);

		if (btnslt && !btnPress) {
			if (slt == false) {
				slt = true; yslt = yhero; psslt = -.5; btnPress = true;
				effect(5);
			}
		}
		else if (!btnslt) { btnPress = false; }

		//###### COLLISIONE
		if (slt) {
			yhero += psslt;
			if (yhero < yslt - 15) { psslt = .5; }
			if (psslt > 0) {
				if (!TV.get_pixel(xhero - 1, yhero + 6) && !TV.get_pixel(xhero, yhero + 6) && !TV.get_pixel(xhero + 1, yhero + 6)) {
					slt = false;
				}
			}
		}
		else {
			//###### COLLISIONE
			if (!TV.get_pixel(xhero - 1, yhero + 6) && !TV.get_pixel(xhero, yhero + 6) && !TV.get_pixel(xhero + 1, yhero + 6)) {
				slt = false;
				yhero += 1;
			}
		}

		//###### HERO
		if (xhero > oxhero) { poshero = 1; }
		else if (xhero < oxhero) { poshero = 0; }
		hero(xhero, yhero, poshero, WHITE);
		oxhero = xhero;

		//###### HERO COLLISION MOSTER
		for (uint8_t t = 0; t < totmos; t++) {
			if ((xmos[t] - 1) + wdmoscol[t] / 2 > xhero - wdherocol / 2 && (xmos[t] - 1) - wdmoscol[t] / 2 < xhero + wdherocol / 2 &&
				(ymos[t] - 1) + hgmoscol[t] / 2 > (yhero + 2) - hgherocol / 2 && (ymos[t] - 1) - hgmoscol[t] / 2 < (yhero + 2) + hgherocol / 2) {
				energyHero(-.1);
				effect(0);
			}
		}

		//###### HERO COL OBJECT
		for (uint8_t t = 0; t < maxobj; t++) {
			if (objlive[t]) {
				if ((xobj[t] + 1) + wdobjcol[t] / 2 > xhero - wdherocol / 2 && (xobj[t] + 1) - wdobjcol[t] / 2 < xhero + wdherocol / 2 &&
					(yobj[t] - 1) + hgobjcol[t] / 2 > yhero - hgherocol / 2 && (yobj[t] - 1) - hgobjcol[t] / 2 < yhero + hgherocol / 2) {
					croce(xobj[t], yobj[t], BLACK);
					objlive[t] = false;
					score += 10;
					endobj -= 1;
					if (endobj == 0) { endlevel = true; }
					xexp = xobj[t];	yexp = yobj[t];	liveexp = true;
					effect(3);
				}
			}
		}

		//###### HERO COL LIFE (CUORE)
		if (lifelive) {
			//TV.draw_rect(xlife - wdlifecol / 2, (ylife + 1) - hglifecol / 2, wdlifecol, hglifecol, WHITE);
			if (xlife + wdlifecol / 2 > xhero - wdherocol / 2 && xlife - wdlifecol / 2 < xhero + wdherocol / 2 &&
				(ylife - 2) + hglifecol / 2 > yhero - hgherocol / 2 && (ylife - 2) - hglifecol / 2 < yhero + hgherocol / 2) {
				cuore(xlife, ylife, BLACK);
				lifelive = false;
				energyHero(1);
				score += 100;
				xexp = xlife; yexp = ylife; liveexp = true;
				effect(4);
			}
		}

		//###### HERO COL DOOR END LEVEL
		if (endlevel) {
			if (xhero + wdherocol / 2 > 100 && xhero - wdherocol / 2 < 103 && yhero < 9) {

				level += 1;
				TV.clear_screen();
				//###### PRINT LEVEL
				printLevel(level);
				//###### 
				effect(6);
				unsigned long tmlev = millis();
				while (millis() - tmlev <= 2000)
				{
					TIMSK3 = 0b00000000;//disattiva interrupt timer 3
					TV.delay_frame(1);
					TIMSK3 = 0b00000001;//attiva interrupt timer 3
				}
				//TV.delay(2000);
				//TIMSK3 = 0b00000000;//disattiva interrupt timer 3
				//###### 
				TV.clear_screen();
				//###### END LEVEL
				currPosLevel += 1;
				if (currPosLevel >= endLevelEarth) {
					//###### 
					if (PlatformSpace == 0) {
						//###### 
						PlatformSpace = 1;
						//###### 
						SeletTypeStartGame();
						return;
					}
				}

				//###### GENERATORE DI SPAZI NELLA MAPPA
				generaMappa();
				//###### GENERATORE MOSTRI
				generaMostri();
				generaoggetti();
				btnPress = false;
				endlevel = false;

				//###### START HERO
				xhero = 5;
				yhero = 85;
				slt = false;

			}
		}

#pragma endregion
	}
	else {
#pragma region ############################################ SPACE
		TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
				//###### PREPARA TERRA
		vi += pvi;
		if (pvi > 0 && vi >= ovi + vl) {
			vl = random(20) + 1;
			ovi = vi;
			if (vi - vl < 5) { pvi = 0.25; }
			else { pvi = -0.25; }
		}if (pvi < 0 && vi <= ovi - vl) {
			vl = random(20) + 1;
			ovi = vi;
			if (vi + vl > 50) { pvi = -0.25; }
			else { pvi = 0.25; }
		}

		//###### 
		mystart = analogRead(ASSE_Y);
		if (mystart > 510) { yhero += 1; if (yhero > 100) { yhero = 100; } }
		if (mystart < 490) { yhero -= 1; if (yhero < 0) { yhero = 0; } }
		myend = mystart;

		//###### 
		mxstart = analogRead(ASSE_X);
		if (mxstart > 510) { xhero += 1; if (xhero > 100) { xhero = 100; } }
		if (mxstart < 490) { xhero -= 1; if (xhero < 2) { xhero = 2; } }
		mxend = mxstart;

		TIMSK3 = 0b00000000;//###### DISABLE INTERRUPT TIMER 3 (disattiva interrupt timer 3)

		//###### FIRE BUTTON
		uint8_t btnslt = digitalRead(BUTTON_ONE_PIN);
		if (btnslt && !btnPress) {
			fire += 1;
			if (fire > 4) { fire = 0; }
			if (fireon[fire] == false) {
				fireon[fire] = true; xfire[fire] = xhero + 2; yfire[fire] = yhero + 1; btnPress = true;
				oxfire[fire] = xfire[fire]; oyfire[fire] = yfire[fire];
				effect(2);
			}
		}
		else if (!btnslt) { btnPress = false; }

		//###### FIRE MOVE
		for (uint8_t t = 0; t < 5; t++) {
			if (fireon[t]) {
				TV.set_pixel(oxfire[t], oyfire[t], BLACK);
				xfire[t] += 1;
				if (xfire[t] >= 102 || TV.get_pixel(xfire[t], yfire[t])) { fireon[t] = false; oxfire[0] = 0; oyfire[0] = 0; }
				//###### COLLISION FIRE WITH ALIEN
				for (uint8_t t1 = 0; t1 < totAlien; t1++) {
					if (liveastro[t1]) {
						if (xfire[t] > xalien[t1] - 2 && xfire[t] < (xalien[t1] - 2) + 4 && yfire[t] > yalien[t1] && yfire[t] < yalien[t1] + 4) {
							liveastro[t1] = false;
							xexp = xalien[t1];
							yexp = yalien[t1];
							fireon[t] = false;
							liveexp = true;
							score += 50;
							energyHero(.2);
							effect(4);
						}
					}
				}
				//###### COLLISION FIRE WITH MISSILE
				for (uint8_t t1 = 0; t1 < totmiss; t1++) {
					if (livemiss[t1]) {
						if (xfire[t] > xmiss[t1] - 1 && xfire[t] < (xmiss[t1] - 1) + 2 && yfire[t] > ymiss[t1] - 3 && yfire[t] < (ymiss[t1] - 3) + 5) {
							livemiss[t1] = false;
							xexp = xmiss[t1];
							yexp = ymiss[t1];
							fireon[t] = false;
							liveexp = true;
							score += 10;
							effect(3);
						}
					}
				}

			}
		}

		//###### HERO BLACK
		astro(oxhero, 1 + oyhero, BLACK);

		//###### ALIEN
		for (uint8_t t = 0; t < totAlien; t++) {
			if (liveastro[t]) {
				alien(oxalien[t], oyalien[t], nxmove, BLACK);
				if (iniastro[t] == 1) { pxalien[t] -= .2; }
				if (pxalien[t] <= 70 && iniastro[t] == 1) { iniastro[t + 1] = 1; }
				if (pxalien[t] <= 60 && iniastro[t] == 1) { iniastro[t] = 2; iniastro[t + 1] = 1; }
				if (iniastro[t] == 2) { a[t] += 1; if (a[t] > 156) { a[t] = 0; } }
				if (iniastro[t] > 0) {
					xalien[t] = pxalien[t] + 20 * fcos[a[t]];
					yalien[t] = pyalien[t] + 20 * fsin[a[t]];
				}
				//###### COLLISION ASTRO WITH HERO
				if (xhero > xalien[t] - 2 && xhero<(xalien[t] - 2) + 4 && yhero > yalien[t] && yhero < yalien[t] + 4) {
					energyHero(-.5);
					effect(0);
				}
			}
		}

		//##### FINE ALIEN
		endAlien = true;
		for (uint8_t t = 0; t < totAlien; t++) { if (liveastro[t] && iniastro[t] > 0) { endAlien = false; } }

		//###### MISSILE
		endmiss = true;
		for (uint8_t t = 0; t < totmiss; t++) {
			if (livemiss[t]) {
				endmiss = false;
				xmiss[t] -= psmiss[t]; if (xmiss[t] <= 0) { xmiss[t] = 102; psmiss[t] = 1; startmiss[t] = 30 + random(10) * 5; }
				if (xmiss[t] == 102) { ymiss[t] = (103 - vi) - 3; }
				if (xmiss[t] <= startmiss[t]) {
					ymiss[t] -= (float)random(40, 100) / 100; psmiss[t] = (float)random(50, 100) / 100;
				}
				missile(oxmiss[t], oymiss[t], 0, BLACK);
				//###### COLLISION MISSILE WITH HERO
				if (xhero > xmiss[t] - 1 && xhero<(xmiss[t] - 1) + 2 && yhero>ymiss[t] - 3 && yhero < (ymiss[t] - 3) + 5) {
					energyHero(-1);
					effect(0);
				}
			}
		}

		//###### FINE EARTH SPACE
		if (endLevelEarthSpace > 0) {
			endAlien = false;
			endmiss = false;
			currPosEarthSpace++;
			if (currPosEarthSpace >= endLevelEarthSpace) { endAlien = true; endLevelEarthSpace = 0; }
		}

		//###### FINE ALIEN/MISSILE
		if ((endAlien && astromiss == 0) || (endmiss && astromiss == 1)) {
			//###### END LEVEL
			currPosLevel++;
			if (currPosLevel >= endLevelSpace) {
				level += 1;
				TV.clear_screen();
				//###### 
				printLevel(level);
				//###### 
				effect(6);
				unsigned long tmlev = millis();
				while (millis() - tmlev <= 2000)
				{
					TIMSK3 = 0b00000000;//###### DISABLE INTERRUPT TIMER 3 (disattiva interrupt timer 3)
					TV.delay_frame(1);
					TIMSK3 = 0b00000001;//###### ENABLE INTERRUPT TIMER 3 (attiva interrupt timer 3)
				}
				//###### 
				TV.clear_screen();
				//###### 
				if (PlatformSpace == 1) {
					//###### 
					PlatformSpace = 0;
					//###### 
					SeletTypeStartGame();
					return;
				}
			}
			spaceearth = random(0, 3);//###### DECIDE QUALE MODELLO SI SPAZIO TERRA
			callnext();
		}

		//###### EXPLOSION
		if (liveexp) { explosion(oxexp, oyexp, BLACK); }

		//###### TERRAIN (TERRENO)
		switch (spaceearth)
		{
		case 0:
			if (random(0, 2) == 0) {
				//###### ABOVE (SOPRA)
				TV.draw_line(103, 0, 103, vi, WHITE);
			}
			else {
				//###### ABOVE CRINE (SOPRA STORTO)
				TV.draw_line(103, 0, 100, vi, WHITE);
			}
			break;
		case 1:
			if (random(0, 2) == 0) {
				//###### UNDER (SOTTO)
				TV.draw_line(103, 103 - vi, 103, 103, WHITE);
			}
			else {
				//###### CRINE UNDER (SOTTO STORTO)
				TV.draw_line(103, 103 - vi, 100, 103, WHITE);
			}
			break;
		case 2:
			//###### ABOVE/UNDER CRINE ROAD (SOPRA/SOTTO STRADA STORTA)
			TV.draw_line(103, 0, 100, vi, WHITE);
			TV.draw_line(100, vi + 20, 103, 103, WHITE);
			break;
		default:
			break;
		}

		//###### SCORE GAME
		printScore(1, 105, score, 1);

		//###### ENERGY HERO
		TV.draw_line(52, 105, 52, 109, BLACK);
		TV.draw_rect(53, 105, 50, 4, WHITE, BLACK);
		TV.draw_rect(53, 106, energy, 2, WHITE, WHITE);

		//###### SCROLLING
		TV.shift(1, LEFT);

		//###### FIRE
		for (uint8_t t = 0; t < 5; t++) {
			if (fireon[t]) {
				TV.set_pixel(xfire[t], yfire[t], WHITE);
				oxfire[t] = xfire[t];
				oyfire[t] = yfire[t];
			}
		}

		//###### HERO WHITE
		astro(xhero, 1 + yhero, WHITE);

		//###### ALIEN
		for (uint8_t t = 0; t < totAlien; t++) {
			if (liveastro[t]) {
				//TV.draw_rect(xalien[t], yalien[t], 4, 4, WHITE);
				if (iniastro[t] > 0) {
					alien(xalien[t], yalien[t], nxmove, WHITE);
					oxalien[t] = xalien[t];
					oyalien[t] = yalien[t];
				}
			}
		}

		//###### MISSILE
		for (uint8_t t = 0; t < totmiss; t++) {
			if (livemiss[t]) {
				missile(xmiss[t], ymiss[t], 0, WHITE);
				oxmiss[t] = xmiss[t];
				oymiss[t] = ymiss[t];
			}
		}

		//###### EXPLOSION
		if (liveexp) { explosion(xexp, yexp, WHITE); }
		oxexp = xexp;
		oyexp = yexp;

		oxhero = xhero;
		oyhero = yhero;

		//###### COLLISION HERO WITH EARTH
		//TV.set_pixel(xhero + 2, 1 + yhero, WHITE);
		if (TV.get_pixel(xhero + 2, yhero + 1)) {
			energyHero(-1);
			yhero -= 10; if (yhero <= 0) { yhero = 0; }
			effect(0);
		}
		else if (TV.get_pixel(xhero + 2, yhero)) {
			energyHero(-1);
			yhero += 10; if (yhero >= 100) { yhero = 100; }
			effect(0);
		}
#pragma endregion
	}

	TV.delay_frame(1);
}
